----------------------------------------------------------------------------------
-- Company: Univ Lyon, UJM-Saint-Etienne, CNRS, Laboratoire Hubert Curien UMR 5516, F-42023, SAINT-ETIENNE, France
-- Creator: Cédric Marchand 
--
-- Create Date:   11:18:40 10/29/2015
-- Design Name:   
-- Module Name:   /home/cmarcha2/ultralight/optimized/Lilliput_v4/Top_level_tb.vhd
-- Project Name:  Lilliput_v4
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: Top_level
-- 
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends
-- that these types always be used for the top-level I/O of a design in order
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
 
-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--USE ieee.numeric_std.ALL;
 
ENTITY Top_level_tb IS
END Top_level_tb;
 
ARCHITECTURE behavior OF Top_level_tb IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT Top_level
    PORT(
         rstb_i : IN  std_logic;
         clk_i : IN  std_logic;
         control_i : IN  std_logic_vector(1 downto 0);
         data_i : IN  std_logic_vector(7 downto 0);
         key_i : IN  std_logic_vector(7 downto 0);
         busy_o : OUT  std_logic;
         key_valid : OUT  std_logic;
         done_o : OUT  std_logic;
         data_o : OUT  std_logic_vector(7 downto 0)
        );
    END COMPONENT;
    

   --Inputs
   signal rstb_i : std_logic := '0';
   signal clk_i : std_logic := '0';
   signal control_i : std_logic_vector(1 downto 0) := (others => '0');
   signal data_i : std_logic_vector(7 downto 0) := (others => '0');
   signal key_i : std_logic_vector(7 downto 0) := (others => '0');

 	--Outputs
   signal busy_o : std_logic;
   signal key_valid : std_logic;
   signal done_o : std_logic;
   signal data_o : std_logic_vector(7 downto 0);

   -- Clock period definitions
   constant clk_i_period : time := 10 ns;
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: Top_level PORT MAP (
          rstb_i => rstb_i,
          clk_i => clk_i,
          control_i => control_i,
          data_i => data_i,
          key_i => key_i,
          busy_o => busy_o,
          key_valid => key_valid,
          done_o => done_o,
          data_o => data_o
        );

   -- Clock process definitions
   clk_i_process :process
   begin
		clk_i <= '1';
		wait for clk_i_period/2;
		clk_i <= '0';
		wait for clk_i_period/2;
   end process;
 

   -- Stimulus process
   stim_proc: process
   begin		
      -- hold reset state for 100 ns.
      wait for 100 ns;	
      rstb_i <= '1';
      -- Encryption vector 2
      wait for clk_i_period*2;
      control_i <= "01";
      key_i     <= x"00";
      wait for clk_i_period*2;
      control_i <= "00";
      key_i     <= x"00";
--      key_i     <= x"10"; 
--      wait for clk_i_period;
--      key_i     <= x"32"; 
--      wait for clk_i_period;
--      key_i     <= x"54";
--      wait for clk_i_period;
--      key_i     <= x"76";
--      wait for clk_i_period;
--      key_i     <= x"98"; 
--      wait for clk_i_period;
--      key_i     <= x"ba"; 
--      wait for clk_i_period;
--      key_i     <= x"dc";
--      wait for clk_i_period;
--      key_i     <= x"fe";
--      wait for clk_i_period;
--      key_i     <= x"10"; 
--      wait for clk_i_period;
--      key_i     <= x"32"; 
--      wait for clk_i_period;
--      key_i     <= x"54";
--      wait for clk_i_period;
--      key_i     <= x"76";
--      wait for clk_i_period;
--      key_i     <= x"98"; 
--      wait for clk_i_period;
--      key_i     <= x"ba"; 
--      wait for clk_i_period;
--      key_i     <= x"dc";
--      wait for clk_i_period;
--      key_i     <= x"fe";
      wait until busy_o = '0';
      wait for clk_i_period*2;
      control_i <= "11";
      wait for clk_i_period*2;
      control_i <= "00";
--      data_i <= x"00";
      data_i <= x"d3";
--      data_i <= x"6d";
--      data_i     <= x"10"; 
      wait for clk_i_period;
      data_i <= x"ce";
--      data_i <= x"8b";
--      data_i     <= x"32"; 
      wait for clk_i_period;
      data_i <= x"2b";
--      data_i <= x"42";
--      data_i     <= x"54";
      wait for clk_i_period;
      data_i <= x"0a";
--      data_i <= x"85";
--      data_i     <= x"76";
      wait for clk_i_period;
      data_i <= x"58";
--      data_i <= x"f7";
--      data_i     <= x"98"; 
      wait for clk_i_period;
      data_i <= x"c0";
--      data_i <= x"10";
--      data_i     <= x"ba";
      wait for clk_i_period;
      data_i <= x"bd";
--      data_i <= x"f4";
--      data_i     <= x"dc";
      wait for clk_i_period;
      data_i <= x"1a";
--      data_i <= x"2c";
--      data_i     <= x"fe";
      wait for clk_i_period;
      data_i     <= x"00";
      wait until busy_o = '0';
      -- insert stimulus here 

      wait;
   end process;

END;
