----------------------------------------------------------------------------------
-- Company: Univ Lyon, UJM-Saint-Etienne, CNRS, Laboratoire Hubert Curien UMR 5516, F-42023, SAINT-ETIENNE, France
-- Creator: Cédric Marchand  
-- 
-- Create Date:    11:21:09 11/12/2015 
-- Design Name: 
-- Module Name:    mix_col - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity mix_col is
  port(
    state_i : in std_logic_vector(63 downto 0);
    state_o : out std_logic_vector(63 downto 0)
  );
end mix_col;

architecture Behavioral of mix_col is

  COMPONENT mix_row
	PORT(
		state_i : IN std_logic_vector(63 downto 0);
		state_o : out std_logic_vector(63 downto 0)       
		);
	END COMPONENT;
  
  signal row_1 : std_logic_vector(63 downto 0);
  signal row_2 : std_logic_vector(63 downto 0);
  signal row_3 : std_logic_vector(63 downto 0);

begin

  Inst_mix_row1: mix_row PORT MAP(
		state_i => state_i,
		state_o => row_1
	);
  
  Inst_mix_row2: mix_row PORT MAP(
		state_i => row_1,
		state_o => row_2
	);
  
  Inst_mix_row3: mix_row PORT MAP(
		state_i => row_2,
		state_o => row_3
	);
  
  Inst_mix_row4: mix_row PORT MAP(
		state_i => row_3,
		state_o => state_o
	);

end Behavioral;

